--[[	
Title: myBigIgnite
Addon version: 1.4
Game version: 4.0.6
Author: Istaran | Medivh - EU
Pieces of code from IgniteTracker by Siffin (Korgath US).
myBigIgnite	is licensed under Creative Commons Attribution - No Commercial Use 3.0. myBigIgnite est sous licence Creative Commons Paternit - Pas d'Utilisation Commerciale 3.0. See: http://creativecommons.org/licenses/by-nc/3.0/
]]



if (select(2, UnitClass("player")) ~= "MAGE") then
   return
end

local myBigIgnite = LibStub("AceAddon-3.0"):NewAddon("myBigIgnite", "AceConsole-3.0", "AceEvent-3.0")
local mBIrefresh = 0.1
local remainTime = {}
local spellenabled = {}
local spellname = {}
local spellcount = 0
local mBIversion = 1.4
local allDot, mBI_lag
local mBIignite = 0


-- Create Default Database
local DBDefault = {
	global = {
		mBIframe = {
			position = {
				POINT = "CENTER",
				PARENT = "UIParent",
				RELATIVE = "CENTER",
				XCOORD = 0,
				YCOORD = 0,
			},
			movable = true,		
		},
		mBIspell = {
			["Ignite"] = {
				["enabled"] = true,
				["locname"]= "Ignite",
				["id"] = 12654,
				},
			["Living Bomb"] = {
				["enabled"] = true,
				["locname"]= "Living Bomb",
				["id"] = 44457,
				},
			["Pyroblast"] = {
				["enabled"] = false,
				["locname"]= "Pyroblast",
				["id"] = 11366,
				},
			["Pyroblast!"] = {
				["enabled"] = false,
				["locname"]= "Pyroblast!",
				["id"] = 92315,
				},
			["Frostfire Bolt"] = {
				["enabled"] = false,
				["locname"]= "Frostfire Bolt",
				["id"] = 44614,
				},
				
		},
		
		mBItexthiding = false,
		mBIvalue = 0,
		mBIperct = 0.75,
		mBIlag = 0.5,
		mBIlocale = "enGB",
	},
}

--When Initializing the Addon, generate the database and print a splash message
function myBigIgnite:OnInitialize()
	
	self.db = LibStub("AceDB-3.0"):New("mBIdb", DBDefault)
	self:RegisterChatCommand("myBigIgnite","SlashCommand")
	self:RegisterChatCommand("mbi","SlashCommand")

end



function myBigIgnite:LocalCheck()
	local locale = GetCVar("locale")
	if (locale ~= "enGB" and self.db.global.mBIlocale == "enGB") then
		for k1, v1 in pairs(self.db.global.mBIspell) do
			print(k1)
			for k2, v2 in pairs(v1) do
				if (k2 == "id") then
					self.db.global.mBIspell[k1].locname = GetSpellInfo(v2)
				end
			end
		end
		self.db.global.mBIlocale = locale
	elseif (locale == "enGB" and self.db.global.mBIlocale ~= "enGB") then
		for k1, v1 in pairs(self.db.global.mBIspell) do
			self.db.global.mBIspell[k1].locname = DBDefault.global.mBIspell[k1].locname
		end
		self.db.global.mBIlocale = locale
	end
end		


--When the addon becomes enabled, create the frame, and register the combat log event
function myBigIgnite:OnEnable()
	
	myBigIgnite:LocalCheck()
	self:CreateFrame()
	--self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","EventHandler")
	self:RegisterEvent("PLAYER_REGEN_DISABLED","InCombat")
	self:RegisterEvent("PLAYER_LEAVE_COMBAT","InCombat")
	self:RegisterEvent("PLAYER_REGEN_ENABLED","InCombat")
	mBIframe:SetScript("OnEvent", function(self,event,...) mBIEvents[event](self,...) end)
	for k,v in pairs(mBIEvents) do
	    mBIframe:RegisterEvent(k)
	end
	mBIfcombat:SetScript("OnUpdate", function(self, elapsed) myBigIgnite:OnUpdate(self, elapsed) end)
	
	local i = 1
	local k1, v1, k2, v2
	for k1, v1 in pairs(self.db.global.mBIspell) do
		for k2, v2 in pairs(v1) do
			if (k2 == "enabled") then
				spellenabled[i] = v2
					if spellenabled[i] then
						if string.find(k1, "Pyroblast") then
							spellcount = spellcount + 0.5
						else
							spellcount = spellcount + 1
						end
					end
			elseif (k2 == "locname") then
				spellname[i] = v2
			end
		end
	i = i + 1	
	end

	mBI_lag = tonumber(self.db.global.mBIlag)
end




--Options
function myBigIgnite:SlashCommand(arg)
	
	t = {}
	c = 0
	for token in string.gmatch(arg, "[^%s]+") do
		t[c] = token
		c = c+1
	end
	
	-- Check for component to modify
	if t[0] == "reset" then
			self.db.global.mBIframe.position = "CENTER","UIParent","CENTER",0,0
			self.db.global.mBIframe.movable = true
			self.db.global.mBIhiding = false
			self.db.global.mBIvalue = 0
			self.db.global.mBIperct = 0.75
			mBIframe:SetPoint(self.db.global.mBIframe.position)
			mBIframe.text:Show()
			myBigIgnite:MoveFrame()
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680myBigIgnite has been reset")
	
	elseif t[0] == "frame" then
		if t[1] == "unlock" then
			self.db.global.mBIframe.movable = true
			myBigIgnite:MoveFrame()
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Display frame unlocked")
		elseif t[1] == "lock" then
			self.db.global.mBIframe.movable = false
			myBigIgnite:MoveFrame()
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Display frame locked")
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000myBigIgnite \"/mbi frame\" options:")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680lock - locks the frame")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680unlock - unlocks the frame")
		end
	
	elseif t[0] == "value" then
		if t[1] == "set" then
			self.db.global.mBIvalue = t[2]
			mBIwarning = false
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Optimal ignite tick value set to " .. t[2])
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Intermediate ignite tick value set to " .. tonumber(self.db.global.mBIvalue)*tonumber(self.db.global.mBIperct))
		elseif t[1] == "percent" then
			self.db.global.mBIperct = tonumber(t[2])/100
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Percentage of optimal ignite tick value set to " .. t[2])
		elseif t[1] == "print" then
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Optimal ignite tick value set to " .. self.db.global.mBIvalue)
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Percentage of optimal ignite tick value set to " .. tonumber(self.db.global.mBIperct)*100 .. "%")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Good ignite tick value is " .. tonumber(self.db.global.mBIvalue)*tonumber(self.db.global.mBIperct))
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000myBigIgnite \"/mbi value\" options:")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680set ##### - sets the value of an optimal ignite tick to #####")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680percent ## - sets the percentage used to calculate a good value for an ignite tick to ##")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680print - prints the settings")
		end
	
	elseif t[0] == "hide" then
		if t[1] == "auto" then
			self.db.global.mBIhiding = true
			mBIframe.text:Hide()
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Autohide is enabled")
		elseif t[1] == "never" then
			self.db.global.mBIhiding = false
			mBIframe.text:Show()
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Autohide is disabled")
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680auto - myBigIgnite is automatically hidden when no ignite is present on the target")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680never - myBigIgnite is always shown")
		end
	
	elseif t[0] == "spell" then
		if t[1] == "lb" then
			if self.db.global.mBIspell["Living Bomb"].enabled then
				self.db.global.mBIspell["Living Bomb"].enabled = false
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Living Bomb tracking is disabled")
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000Please reload your UI")
			else
				self.db.global.mBIspell["Living Bomb"].enabled = true
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Living Bomb tracking is enabled")
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000Please reload your UI")
			end
		elseif t[1] == "pyro" then
			if self.db.global.mBIspell["Pyroblast"].enabled then
				self.db.global.mBIspell["Pyroblast"].enabled = false
				self.db.global.mBIspell["Pyroblast!"].enabled = false
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Pyroblast tracking is disabled")
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000Please reload your UI")
			else
				self.db.global.mBIspell["Pyroblast"].enabled = true
				self.db.global.mBIspell["Pyroblast!"].enabled = true
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Pyroblast tracking is enabled")
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000Please reload your UI")
			end
		elseif t[1] == "ffb" then
			if self.db.global.mBIspell["Frostfire Bolt"].enabled then
				self.db.global.mBIspell["Frostfire Bolt"].enabled = false
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Frostfire Bolt tracking is disabled")
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000Please reload your UI")
			else
				self.db.global.mBIspell["Frostfire Bolt"].enabled = true
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Frostfire Bolt tracking is enabled")
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000Please reload your UI")
			end
		elseif t[1] == "print" then
			if	self.db.global.mBIspell["Living Bomb"].enabled then
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Living Bomb tracking is enabled")
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Living Bomb tracking is disabled")
			end
			if self.db.global.mBIspell["Pyroblast"].enabled then
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Pyroblast tracking is enabled")
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Pyroblast tracking is disabled")
			end
			if	self.db.global.mBIspell["Frostfire Bolt"].enabled then
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Frostfire Bolt tracking is enabled")
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Frostfire Bolt tracking is disabled")
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680lb - to enable/disable tracking of " .. self.db.global.mBIspell["Living Bomb"].locname .. "dot")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680pyro - to enable/disable tracking of " .. self.db.global.mBIspell["Pyroblast"].locname .. "dot")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680ffb - to enable/disable tracking of " .. self.db.global.mBIspell["Frostfire Bolt"].locname .. "dot")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680print - prints the current dot tracking settings")
		end
		
	elseif t[0] == "help" then
		DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000myBigIgnite v" .. mBIversion .. " | Istaran - Medivh EU")
		DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680/mbi frame - Allow you to move or lock the frame")
		DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680/mbi value - Set the two display thresholds")
		DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680/mbi hide - Set wether mBI is automatically hidden in the absence of ignite damages on your target")
		DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680/mbi spell - Enable or disable which dot to be tracked")
		DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680/mbi reset - resets myBigIgnite settings to its default")
		DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680/mbi help - this dialog")

	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000myBigIgnite: " .. "|cffFFE680\"/mbi help\" for options")
	end
	
end


--Generate the frame
function myBigIgnite:CreateFrame()
	
	mBIframe, mBIEvents = CreateFrame("Frame", "mBIFrame", UIParent),{}
	local pos = self.db.global.mBIframe.position
	mBIframe:SetPoint(pos["POINT"], "UIParent", pos["RELATIVE"],pos["XCOORD"],pos["YCOORD"])
	mBIframe:SetFrameStrata("LOW")
	mBIframe:SetWidth(20)
	mBIframe:SetHeight(40)
	mBIframe:Show()
	
	if self.db.global.mBIframe.movable then
		myBigIgnite:MoveFrame()
	else
		myBigIgnite:MoveFrame()
	end
	
	mBIfcombat = CreateFrame("Frame", "mBIfcombat", mBIframe)
	mBIfcombat:SetPoint("CENTER", mBIframe, "CENTER", 0, 0)
	mBIfcombat:SetFrameStrata("LOW")
	mBIfcombat:SetWidth(0)
	mBIfcombat:SetHeight(0)
	mBIfcombat:SetMovable(false)
	mBIfcombat:EnableMouse(false)
	mBIfcombat:Hide()
	
	mBIframe.text = mBIframe:CreateFontString()
	mBIframe.text:SetPoint("RIGHT", mBIframe, "RIGHT", 0,0)
	mBIframe.text:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
	mBIframe.text:SetTextColor(1, 0.5, 0)
	mBIframe.text:SetText("0")
	
	if self.db.global.mBIhiding then 
		mBIframe.text:Hide()
		mBIframe.text:SetText("0")
	end
	--myBigIgnite:TextPop()

	

		
	--texture = frame:CreateTexture()
	--texture:SetAllPoints(frame)
	--texture:SetTexture("Interface\\Addons\\myBigIgnite\\texture2.tga")
	--texture:SetVertexColor(1,.5,.15)

	DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000myBigIgnite v"..mBIversion.. " loaded")
	if (tonumber(self.db.global.mBIvalue) == 0) then
		DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000myBigIgnite: ".."|cffFFE680Your display threshold has not been set. Please use /mbi value to set the threshold")
	end
	
end


function myBigIgnite:InCombat(event,...)
	
	if (event == "PLAYER_REGEN_DISABLED") then
		mBIfcombat:Show()
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","EventHandler")
	else
		mBIfcombat:Hide()
		self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		mBIignite = 0
		mBIframe.text:SetTextColor(1, 0.5, 0)
		mBIframe.text:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
		mBIframe.text:SetText(mBIignite)
		if self.db.global.mBIhiding then
			mBIframe.text:Hide()
		end
		if mBIwarning then
			DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000myBigIgnite: ".."|cffFFE680Your display threshold has not been set. Please use \"/mbi value\" to set the threshold")
			UIErrorsFrame:AddMessage("|cffFF8000Your display threshold has not been set. Please use \"/mbi value\" to set the threshold")
		end
	end
		
end

function myBigIgnite:OnUpdate(self, elapsed)
	
	self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed
	if (self.TimeSinceLastUpdate > mBIrefresh) then
		local curTime = GetTime()
		local i
		local dotnum = 0
		for i = 1, 5 do
			local name, _, _, _, _, duration, expTime, unitCaster, _, _, _ = UnitAura("target", spellname[i], nil, "PLAYER|HARMFUL")
			if spellenabled[i] then
				if (expTime ~= nil) then
					remainTime[i] = expTime - curTime
					if remainTime[i] <= 0 then
						remainTime[i] = 0
					end
				else
					remainTime[i] = 0
				end
				
				if (remainTime[i] >= mBI_lag) then
					dotnum = dotnum + 1
				end
				
				myBigIgnite:DBuffsDisplay(spellname[i], remainTime[i])
			end
			
			i = i+1
		end
		
		if (dotnum == spellcount) then
			allDot = true
		else
			allDot = false
		end
		myBigIgnite:TextHandler()


		-- local startCD, durationCD, enabledCD = GetSpellCooldown("Combustion")
		-- print(startCD, durationCD, enabledCD)
		-- print(curTime)


		
		self.TimeSinceLastUpdate = 0
	end

end
		

function myBigIgnite:DBuffsDisplay(spellname, remaintime)
	
	if (spellname == self.db.global.mBIspell.Ignite.locname) then
		if (remaintime >= mBIrefresh) then
			mBIframe.text:Show()
			mBIframe.text:SetText(mBIignite)
		else
			mBIignite = 0
			mBIframe.text:SetTextColor(1, 0.5, 0)
			mBIframe.text:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
			mBIframe.text:SetText(mBIignite)
			if self.db.global.mBIhiding then
				mBIframe.text:Hide()
			end
			
		end
	end
	
end
	

function myBigIgnite:TextHandler()
	local mBI_value, mBI_perct = tonumber(self.db.global.mBIvalue), tonumber(self.db.global.mBIperct)
	if (mBIignite >= mBI_value) and allDot then 
		mBIframe.text:SetTextColor(0, 1, 0)
		mBIframe.text:SetFont("Fonts\\FRIZQT__.TTF", 20, "OUTLINE")
	elseif (mBIignite >= mBI_value*mBI_perct) and allDot then
		mBIframe.text:SetTextColor(0.5, 0.5, 1)
		mBIframe.text:SetFont("Fonts\\FRIZQT__.TTF", 20, "OUTLINE")
	else 
		mBIframe.text:SetTextColor(1, 0.5, 0)
		mBIframe.text:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
	end
	
end	


	

-- Spell handler
function myBigIgnite:EventHandler(WOWevent, ...)
	
	local TimeStamp, EventType, SourceGUID, SourceName, SourceFlags, DestGUID, DestName, DestFlags, SpellID, SpellName, SpellSchool, arg12, arg13 = ...
	local pGUID = UnitGUID("player")
	local tGUID = UnitGUID("target")
	--local name, rank, icon = UnitDebuff("target", self.db.global.spellname)
	--local mBI_value, mBI_perct = tonumber(self.db.global.mBIvalue), tonumber(self.db.global.mBIperct)
	
-- [	if SourceGUID and (pGUID == SourceGUID) and DestGUID and (tGUID == DestGUID) and SpellName and (SpellName == "Ignite") then
	-- print("TimeStamp: "..TimeStamp, "EventType: "..EventType) --"SourceGUID: "..SourceGUID)
	-- print("SourceName: "..SourceName, "SourceFlags: "..SourceFlags, "DestGUID: "..DestGUID)
	-- print("DestName: "..DestName, "DestFlags: "..DestFlags, "SpellID: "..SpellID)
	-- print("SpellName: "..SpellName, "SpellSchool: "..SpellSchool, arg12, arg13)
	-- end--]
	
	
	
	
	
	if (mBI_value ~= 0) then
		-- if (tGUID == nil) then
			-- mBIframe.text:SetTextColor(1, 0.5, 0)
			-- mBIframe.text:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
			-- mBIframe.text:SetText("no ignite")
			-- myBigIgnite:TextDisplay()
		-- elseif SourceGUID and (pGUID == SourceGUID) and DestGUID and (tGUID ==DestGUID) and EventType and (EventType == "SPELL_AURA_REMOVED") and SpellName and (SpellName == "Ignite") then
			-- myBigIgnite:TextDisplay()
			-- mBIframe.text:SetTextColor(1, 0.5, 0)
			-- mBIframe.text:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
			-- mBIframe.text:SetText("no ignite")
		if SourceGUID and (pGUID == SourceGUID) and DestGUID and (tGUID == DestGUID) and EventType and string.find(EventType, "_DAMAGE") and SpellName and string.find(SpellName, self.db.global.mBIspell.Ignite.locname) then
		--	mBIframe.text:Show()
			
			
			-- if (arg12 >= mBI_value) then 
				-- myBigIgnite:TextHandler("bigone")
			-- elseif (arg12 >= mBI_value*mBI_perct) then
				-- myBigIgnite:TextHandler("mid")
			-- else 
				-- myBigIgnite:TextHandler(nil)
			-- end
			
			mBIignite = arg12
			--mBIframe.text:SetText(arg12)

		end
	else
		mBIwarning = true
	end

end


-- test wether ignite text must be displayed
-- function myBigIgnite:TextPop()
	-- mBIframe.text:SetTextColor(1, 0.5, 0)
	-- mBIframe.text:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
	-- mBIframe.text:SetText("0")
	
	-- if self.db.global.mBIhiding then
		-- mBIframe.text:Hide()
	
	-- end

-- end


-- enable/disable frame movement and register the position of mBIframe	
function myBigIgnite:MoveFrame()
	
	if self.db.global.mBIframe.movable then
		mBIframe:SetMovable(true)
		mBIframe:SetScript("OnMouseDown", function(mBIframe, button) 
			mBIframe.isMoving = true
			mBIframe:StartMoving()
		end)
	
		mBIframe:SetScript("OnMouseUp", function(mBIframe, button) 
				if (mBIframe.isMoving) then
					mBIframe.isMoving = nil
					mBIframe:StopMovingOrSizing()
					local p,rt,rp,x,y = mBIframe:GetPoint()
					local posi = {}
					posi["POINT"] = p
					posi["PARENT"] = "UIParent"
					posi["RELATIVE"] = rp
					posi["XCOORD"] = x
					posi["YCOORD"] = y
					self.db.global.mBIframe.position = posi
				end
				myBigIgnite.Frame = mBIframe
		end)
	else
		mBIframe:SetScript("OnMouseDown", function(mBIframe, button) 
			mBIframe.isMoving = nil
			mBIframe:StopMovingOrSizing()
		end)
		mBIframe:SetMovable(false)
	end
end



